#ifndef TESTINVENTORY_H_
#define TESTINVENTORY_H_

#include <cxxtest/TestSuite.h>

#include "Inventory.h"
#include "Sword.h"
#include "Bow.h"

class TestInventory : public CxxTest::TestSuite
{
public:
	void testAddWeapon() {
		Sword* s = new Sword;
		Bow* b = new Bow;
		Sword* s2 = new Sword(30, true);
		Inventory inv;
		inv.addWeapon(s);
		inv.addWeapon(b);
		inv.addWeapon(s2);
		TS_ASSERT_EQUALS(inv.getNumWeapons(), 3);
		Bow* b2 = new Bow(20, true);
		inv.addWeapon(b2);
		TS_ASSERT_EQUALS(inv.getNumWeapons(), 4);
	}

	void testGetWeapon() {
		Sword* s = new Sword(20);
		Bow* b = new Bow(30);
		Sword* s2 = new Sword(20, true);
		Inventory inv;
		inv.addWeapon(s);
		inv.addWeapon(b);
		inv.addWeapon(s2);
		Weapon* w = inv.getWeapon(2);
		TS_ASSERT_EQUALS(w->getStrenght(), 20);
		TS_ASSERT_EQUALS(w->isMagic(), true);
	}

	void testUseWeapon() {
		Sword* s = new Sword(20);
		Bow* b = new Bow(30);
		Sword* s2 = new Sword(20, true);
		Inventory inv;
		inv.addWeapon(s);
		inv.addWeapon(b);
		inv.addWeapon(s2);
		int damage = inv.useWeapon(2);
		TS_ASSERT_EQUALS(damage, 40);
		damage = inv.useWeapon(0);
		TS_ASSERT_EQUALS(damage, 20);
	}

	void testRemoveWeapon() {
		Sword* s = new Sword(20);
		Bow* b = new Bow(30);
		Sword* s2 = new Sword(20, true);
		Inventory inv;
		inv.addWeapon(s);
		inv.addWeapon(b);
		inv.addWeapon(s2);
		TS_ASSERT_EQUALS(inv.getNumWeapons(), 3);
		inv.removeWeapon(1);
		TS_ASSERT_EQUALS(inv.getNumWeapons(), 2);
		Weapon* w = inv.getWeapon(1);
		TS_ASSERT_EQUALS(w->getStrenght(), 20);
		TS_ASSERT_EQUALS(w->isMagic(), true);
	}

};

#endif /*TESTINVENTORY_H_*/
